/*
  LOG_DFS_GRFISIMPIEFORN responsvel por gravar as informaes
  na tabela LOGOPERA a partir dos registros que forem includos,
  excludos e alterados na tabela GRFISIMPIEFORN na tela de
  "Parmetros de Grupo Fiscal - Imposto/Inscrio Estadual - Fornecedor"
  Criao: 02/05/2012
  Lucas Primo
*/

CREATE OR REPLACE TRIGGER LOG_DFS_GRFISIMPIEFORN
AFTER DELETE OR INSERT OR UPDATE
ON GRFISIMPIEFORN FOR EACH ROW

DECLARE
  V_CDFILLOGOPER VARCHAR2(4);
  V_USUARIO	 VARCHAR2(40);
  V_TIPO	 VARCHAR2(1);
  V_ITPESQ	 VARCHAR2(40);
  V_DESC	 VARCHAR2(300);
  V_DTOPER	 DATE;
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
BEGIN
   V_TIPO         := '0';
   V_DESC         := '';
   V_CDFILLOGOPER := '';

   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);

   IF DELETING THEN

      V_DESC := V_DESC || ' Aba= ' || 'Imposto/Inscrio Estadual/Fornecedor';
      IF :OLD.CDIMPOSTO IS NOT NULL THEN
         V_DESC := V_DESC || ' CdImpo= ' || :OLD.CDIMPOSTO;
      END IF;

      IF :OLD.CDEMPRESA IS NOT NULL THEN
         V_DESC := V_DESC || ' Empr= ' || :OLD.CDEMPRESA;
      END IF;

      IF :OLD.CDINSCESTA IS NOT NULL THEN
         V_DESC := V_DESC || ' InscEsta= ' || :OLD.CDINSCESTA;
      END IF;

      IF :OLD.CDFORNECED IS NOT NULL THEN
         V_DESC := V_DESC || ' Forne= ' || :OLD.CDFORNECED;
      END IF;

      IF :OLD.CDGRUPOFISC IS NOT NULL THEN
         V_DESC := V_DESC || ' Grupo= ' || :OLD.CDGRUPOFISC;
      END IF;

      V_TIPO         := '3';
      V_ITPESQ       := :OLD.CDEMPRESA||:OLD.CDINSCESTA||:OLD.CDIMPOSTO;
   ELSE
      IF UPDATING THEN

         V_DESC := V_DESC || ' Aba= '      || 'Imposto/Inscrio Estadual/Fornecedor';
         V_DESC := V_DESC || ' CdImpo= '   || :NEW.CDIMPOSTO;
         V_DESC := V_DESC || ' Empr= '     || :NEW.CDEMPRESA;
         V_DESC := V_DESC || ' InscEsta= ' || :NEW.CDINSCESTA;
         V_DESC := V_DESC || ' Forne= '    || :NEW.CDFORNECED;

         IF NVL(:OLD.CDGRUPOFISC, '!') <> NVL(:NEW.CDGRUPOFISC, '!')THEN
            V_DESC := V_DESC || ' Grupo= ' || :NEW.CDGRUPOFISC;
         END IF;

         V_TIPO         := '2';
         V_ITPESQ       := :OLD.CDEMPRESA||:OLD.CDINSCESTA||:OLD.CDIMPOSTO;
      ELSE
         IF INSERTING THEN
            V_DESC := V_DESC || ' Aba= '      || 'Imposto/Inscrio Estadual/Fornecedor';
            V_DESC := V_DESC || ' CdImpo= '   || :NEW.CDIMPOSTO;
            V_DESC := V_DESC || ' Empr= '     || :NEW.CDEMPRESA;
            V_DESC := V_DESC || ' InscEsta= ' || :NEW.CDINSCESTA;
            V_DESC := V_DESC || ' Forne= '    || :NEW.CDFORNECED;
            V_DESC := V_DESC || ' Grupo= '    || :NEW.CDGRUPOFISC;

            V_TIPO         := '1';
            V_ITPESQ       := :NEW.CDEMPRESA||:NEW.CDINSCESTA||:NEW.CDIMPOSTO;
         END IF;
      END IF;
   END IF;
   IF V_TIPO <> '0' THEN

      IF NOT V_DESC IS NULL THEN
         NMUSUARIO(V_USUARIO);
         IF NOT V_USUARIO IS NULL THEN
            V_DTOPER := SYSDATE;
            INSERT INTO LOGOPERA
               (NMTABELA,     DTOPERACAO,   NMRESPOPER,  CDPESQITEM, IDTIPOOPER,  DSOPERACAO,
                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER, CDFILLOGOPER)
            VALUES
               ('GRFISIMPIEFORN',   V_DTOPER,       V_USUARIO,   V_ITPESQ, V_TIPO, SUBSTR(V_DESC,1,300),
                V_DSREMOTEADDR, V_DSREMOTEHOST, V_DSSERVERRDM, V_DSSERVMETHOD, V_DSREMOTEOPER, V_CDFILLOGOPER);

         END IF;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_DFS_GRFISIMPIEFORN','5.42.000'); END;
/